#ifndef CAUR_H
#define CAUR_H

#include <stdio.h>
#include <curl/curl.h>

// Define the URL for the AUR package and the file extension
#define AUR_PACKAGE_URL "https://aur.archlinux.org/cgit/aur.git/snapshot/"
#define AUR_PACKAGE_URL_END ".tar.gz"

// Function to write data to file
size_t write_data(void *ptr, size_t size, size_t nmemb, FILE *stream);

// Function to download a package from the AUR
int download_package(const char *package_name, const char *cache_dir);

// Function to perform a system upgrade
int perform_system_upgrade();

// Function to create cache/build directory
int setup_cache_directory(char *cache_dir, size_t size);

// Function to unpack archived .tar.gz file
// TODO: Look into seeing if other archive formats are used
int unpack_tar_gz(const char *filename, const char *destination);

// Function to build package
int build_package(const char *package_name);

// Reading user config file
FILE *open_config_file(const char *cache_dir);

#endif // CAUR_H
