#include <stdio.h>
#include <stdlib.h>

FILE *open_config_file(const char *cache_dir) {
    char config_file[512];

    // Construct the full path to the config file
    if ((size_t)snprintf(config_file, sizeof(config_file), "%s/config", cache_dir) >= sizeof(config_file)) {
        fprintf(stderr, "config_file was truncated\n");
        return NULL;
    }

    // Attempt to open the config file
    FILE *file = fopen(config_file, "r");
    if (file == NULL) {
        fprintf(stderr, "Could not open config file: %s\n", config_file);
        return NULL;
    }

    return file;
}