#include <stdlib.h>   // For system()
#include <stdio.h>    // For printf(), fprintf()
#include <sys/wait.h> // System calls need to CTFD

#include "caur.h"

int unpack_tar_gz(const char *filename, const char *destination) {
    char command[1024];
    int ret = snprintf(command, sizeof(command), "tar -xzf %s --strip-components=1 -C %s", filename, destination);

    if ((size_t)ret >= sizeof(command)) {
        fprintf(stderr, "Warning: tar command was truncated.\n");
        return 1;
    }

    int result = system(command);
    if (result == -1) {
        fprintf(stderr, "Failed to execute tar command\n");
        return 1;
    } else if (WIFEXITED(result) && WEXITSTATUS(result) != 0) {
        fprintf(stderr, "Unpacking failed with exit status %d.\n", WEXITSTATUS(result));
        return 1;
    }

    printf("Successfully unpacked %s to %s\n", filename, destination);
    return 0;
}

